import { type ComponentType, type RefAttributes } from 'react';
import type { HTMLRuntimeConfig } from '@diplodoc/html-extension';
import type { IHTMLIFrameElementConfig } from '@diplodoc/html-extension/runtime';
import type { PluginRuntime, TransformMeta } from "../withMermaid/types.js";
export type WithYfmHtmlBlockOptions = {
    runtime: PluginRuntime;
};
export type WithYfmHtmlBlockProps = {
    meta: TransformMeta;
    yfmHtmlBlockConfig?: IHTMLIFrameElementConfig;
    /** Works only with html-extension dep version 2.7.1 and higher  */
    htmlRuntimeConfig?: HTMLRuntimeConfig;
};
export declare function withYfmHtmlBlock(opts: WithYfmHtmlBlockOptions): <T extends {
    html: string;
}>(Component: ComponentType<T & RefAttributes<HTMLDivElement>>) => import("react").ForwardRefExoticComponent<import("react").PropsWithoutRef<T & WithYfmHtmlBlockProps> & RefAttributes<HTMLDivElement>>;
